package com.example.ueberwachungssystem;

import static java.lang.Boolean.TRUE;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Context;
import android.hardware.SensorEvent;
import android.os.Bundle;
import android.text.method.ScrollingMovementMethod;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.ToggleButton;

public class MainActivity extends AppCompatActivity implements View.OnClickListener {

    private Logger logger;
    private Accelerometer beschleunigungssensor;
    private TextView textViewLog;
    private Button button1;
    ToggleButton toggleButton1;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setTitle(this.getClass().getSimpleName());
        setContentView(R.layout.activity_main);

        // Logger setup
        textViewLog = findViewById(R.id.textViewLog);
        textViewLog.setMovementMethod(new ScrollingMovementMethod());
        logger = new Logger(this.getClass().getSimpleName(), textViewLog, "");

        toggleButton1 = findViewById(R.id.toggleButton1); //togglebutton um Detektion zu steuern
        toggleButton1.setOnClickListener(this);

        //Button to clear Log while Debugging
        button1 = (Button) findViewById(R.id.button1);
        button1.setOnClickListener(this);

        //Accelerometer Setup
        beschleunigungssensor = new Accelerometer(this, logger, textViewLog);   //logger and textview only for debugging necessary
        beschleunigungssensor.getSensor();

        logger.log("onCreate");
    }

    @Override
    protected void onResume() {
        super.onResume();
    }
    @Override
    protected void onPause() {
        super.onPause();
        beschleunigungssensor.stopDetection();
    }

    @Override
    public void onClick(View v) {
        logger.log("toggleButton1 is clicked");
        if(v == toggleButton1) {
            if (toggleButton1.isChecked()) {
                logger.log("ToggleButton is ON");
                beschleunigungssensor.startDetection();
                logger.log("Detection started");

            } else {
                logger.log("ToggleButton is OFF");
                beschleunigungssensor.stopDetection();
                logger.log("Detection stopped");
            }
        } else if (v == button1) {
            logger.clearLog(); //just to clear log manually if it's too full
        }
    }
}