package com.example.ueberwachungssystem;

import androidx.appcompat.app.AppCompatActivity;

import java.util.concurrent.LinkedBlockingQueue;

public class SensorValueThread implements Runnable {

    private volatile boolean running = false;
    private Thread thread;
    private String threadname = "sensorValueThread";
    Logger logger;
    float x;
    LinkedBlockingQueue<Float> linkedBlockingQueue;
    //AppCompatActivity activity;

    //Constructor muss die LinkedBlockingQueue übergeben bekommen
    public SensorValueThread(LinkedBlockingQueue linkedBlockingQueue){
        this.linkedBlockingQueue = linkedBlockingQueue;
    }

    @Override
    public void run() {
        while (running){
            //Code to execute while running == true, i.e. reading queue and calculate sth.
            try {
                x = linkedBlockingQueue.take();

                Thread.sleep(100);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }

    void start() {
        logger.log("Starting " + threadname + "...");
        running = true;
        thread = new Thread(this);
        thread.setName(threadname);
        thread.start();
        logger.log("..." + threadname + " started");
    }

    void stop() {
        if (!running) {
            logger.log(threadname + " not running");
        } else {
            logger.log("Stopping " + threadname + "...");
            running = false;
            while(true){
                try {
                    thread.join();
                    logger.log("... " + threadname + " stopped");
                    break;
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
        }
    }

}
